<template>
  <div class="container">
    <div class="section">
      <div>
        <h5 class="title is-5">Item Type</h5>
        <div class="buttons is-justify-end">
          <router-link
            class="button is-primary"
            :to="{ name: 'itemType-create' }"
          >
              <span class="icon">
                <i class="material-icons">add</i>
              </span>
            <span>Add</span>
          </router-link>
          <refresh-button :loading="fetching" @refresh="fetchData" />
        </div>
      </div>
      <table class="table is-fullwidth">
        <thead>
        <tr><th>Name</th><th /></tr>
        </thead>
        <tbody>
        <item-type-row
          v-for="itemType in itemTypes"
          :key="itemType.id"
          :item-type="itemType"
          @delete="deleting = true; deleteTarget = $event"
        />
        </tbody>
      </table>
    </div>
    <delete-dialog
      v-if="deleting"
      :show.sync="deleting"
      :loading.sync="fetching"
      :id="deleteTarget.id"
      :name="deleteTarget.name"
      @refresh="fetchData"
    />
  </div>
</template>

<script lang="ts">
  import { Vue, Component } from 'vue-property-decorator';
  import { ItemType, Repository } from '@/modals/itemType';

  @Component<ItemTypeListPage>({
    components: {
      RefreshButton: () => import('@/components/RefreshButton.vue'),
      ItemTypeRow: () => import('@/components/itemType/ItemTypeRow.vue'),
      DeleteDialog: () => import('@/components/itemType/DeleteDialog.vue'),
    },
  })
  export default class ItemTypeListPage extends Vue {
    deleting: boolean = false;
    deleteTarget: ItemType | null = null;
    fetching: boolean = false;
    itemTypes: ItemType[] = [];

    mounted() {
      this.fetchData();
    }

    fetchData() {
      this.fetching = true;
      return Repository.list()
        .then((itemTypes) => {
          this.itemTypes = itemTypes;
          this.fetching = false;
        });
    }

    remove(itemType: ItemType) {
      this.deleting = true;
      this.deleteTarget = itemType;
    }
  }
</script>
